<template>
    <Row class="stock-tech-chart" v-if="id">
      <Row class="record-block">
        <stock-daily-record
            :stock-code="stockCode"
            :data="data"
            :width="recordOptions.width"
            :sync-point="syncPoint"
            :disabled="lockP5Drawing">
          <Row class="option-item" @click.native.stop="">
            <div class="inline-block option-title">Chart: </div>
            <div class="inline-block option-value with-background-color">
              <CheckboxGroup v-model="types">
                <Checkbox label="kd" size="large">KD</Checkbox>
                <Checkbox label="vol" size="large">VOL</Checkbox>
                <Checkbox label="MACD" size="large">MACD</Checkbox>
                <Checkbox label="kd933" size="large">KD-933</Checkbox>
              </CheckboxGroup>
            </div>
          </Row>
          <template v-if="types.includes('kd')">
            <Row class="option-item"  @click.native.stop="">
              <div class="inline-block option-title">AVG Curves: </div>
              <div class="inline-block option-value with-background-color">
                <CheckboxGroup v-model="kdChart.curvesToDraw">
                  <Checkbox label="avgPrice1" size="large">1 AVG</Checkbox>
                  <Checkbox label="avgPrice5" size="large">5 AVG</Checkbox>
                  <Checkbox label="avgPrice20" size="large">20 AVG</Checkbox>
                  <Checkbox label="avgPrice60" size="large">60 AVG</Checkbox>
                  <Checkbox label="avgPrice120" size="large">120 AVG</Checkbox>
                </CheckboxGroup>
              </div>
            </Row>
            <Row class="option-item"  @click.native.stop="">
              <div class="inline-block option-title">Candle Stick: </div>
              <div class="inline-block option-value">
                <i-switch v-model="kdChart.drawCandleStick" size="large">
                  <span slot="open">ON</span>
                  <span slot="close">OFF</span>
                </i-switch>
              </div>
            </Row>
          </template>
          <Row class="option-item" >
            <div class="inline-block option-title">Date Amount: </div>
            <div class="inline-block option-value">
              <Slider v-model="dataAmount" :step="1" :min="20" :max="240" show-stops></Slider>
            </div>
          </Row>
          <Row class="option-item" >
            <div class="inline-block option-title">Show Y: </div>
            <div class="inline-block option-value">
              <i-switch v-model="showCrossHairY" size="large">
                <span slot="open">ON</span>
                <span slot="close">OFF</span>
              </i-switch>
            </div>
          </Row>
        </stock-daily-record>
      </Row>
      <Row class="chart-block">
        <stock-kd-chart v-if="toDrawChart('kd')"
                        :id="id"
                        :data="data"
                        :width="kdOptions.width"
                        :height="kdOptions.height"
                        :data-count="dataAmount"
                        :free-move="freeMove"
                        :show-cross-hair-text="kdOptions.showCrossHairText"
                        :show-cross-hair-y="showCrossHairY"
                        :draw-curve="kdChart.curvesToDraw"
                        :draw-candle-stick="kdChart.drawCandleStick"
                        :sync-point="syncPoint"
                        :sync-more-data-args="loadMoreDataArgs"
                        @on-point="broadcastPointAction"
                        @on-load-more-data="broadcastLoadMoreDataArgsAction">
        </stock-kd-chart>
        <stock-volume-chart v-if="toDrawChart('vol')"
                            :id="id"
                            :data="data"
                            :width="volOptions.width"
                            :height="volOptions.height"
                            :data-count="dataAmount"
                            :free-move="freeMove"
                            :show-cross-hair-text="kdOptions.showCrossHairText"
                            :show-cross-hair-y="showCrossHairY"
                            :sync-point="syncPoint"
                            :sync-more-data-args="loadMoreDataArgs"
                            @on-point="broadcastPointAction"
                            @on-load-more-data="broadcastLoadMoreDataArgsAction">
        </stock-volume-chart>
        <stock-macd-bar-chart v-if="toDrawChart('MACD')"
                              :id="id"
                              :data="data"
                              :width="macdOptions.width"
                              :height="macdOptions.height"
                              :data-count="dataAmount"
                              :free-move="freeMove"
                              :show-cross-hair-text="kdOptions.showCrossHairText"
                              :show-cross-hair-y="showCrossHairY"
                              :sync-point="syncPoint"
                              :sync-more-data-args="loadMoreDataArgs"
                              @on-point="broadcastPointAction"
                              @on-load-more-data="broadcastLoadMoreDataArgsAction">
        </stock-macd-bar-chart>
        <stock-kd933-line-chart v-if="toDrawChart('kd933')"
                                :id="id"
                                :data="data"
                                :width="kd933Options.width"
                                :height="kd933Options.height"
                                :data-count="dataAmount"
                                :free-move="freeMove"
                                :show-cross-hair-text="kdOptions.showCrossHairText"
                                :show-cross-hair-y="showCrossHairY"
                                :sync-point="syncPoint"
                                :sync-more-data-args="loadMoreDataArgs"
                                @on-point="broadcastPointAction"
                                @on-load-more-data="broadcastLoadMoreDataArgsAction">
        </stock-kd933-line-chart>
      </Row>
    </Row>
</template>

<script>
  import StockKdChart from './StockKDChart';
  import StockVolumeChart from './StockVolumeChart'
  import StockMacdBarChart from './StockMACDBarChart'
  import StockKd933LineChart from './StockKD933LineChart'
  import StockDailyRecord from "./StockDailyRecord";

  const emits = {
    emitPoint(point) {
      this.$emit('on-point', point);
    },
    emitLoadMoreData(args) {
      this.$emit('on-load-more-data', args);
    }
  };

  const actions = {
    broadcastPointAction(point) {
      this.emitPoint(point);
    },
    broadcastLoadMoreDataArgsAction(args) {
      this.emitLoadMoreData(args);
    }
  };

  export default {
    name: 'StockTechCharts',
    components: {StockDailyRecord, StockKd933LineChart, StockMacdBarChart, StockVolumeChart, StockKdChart },
    props: {
      id: { type: String, required: true },
      stockCode: { required: true },
      data: { type: Object, required: true },
      syncPoint: { type: Object, default: undefined },
      loadMoreDataArgs: { type: Object, default: () => { return {flag: (new Date()).getTime()}; } },
      recordOptions: { type: Object, default: () => { return {}; } },
      kdOptions: { type: Object, default: () => { return {}; } },
      volOptions: { type: Object, default: () => { return {}; } },
      macdOptions: { type: Object, default: () => { return {}; } },
      kd933Options: { type: Object, default: () => { return {}; } },
      chartTypes: { type: Array, default: () => { return [ 'kd' ]; } }
    },
    data() {
      return {
        dataAmount: 40,
        freeMove: false,
        showCrossHairY: true,
        kdChart: {
          curvesToDraw: [],
          drawCandleStick: true,
        },
        types: [...this.chartTypes], // 'kd', 'vol', 'MACD', 'kd933'
        lockP5Drawing: false,
      };
    },
    methods: {
      ...emits,
      ...actions,
      toDrawChart(chartType) {
        return this.types.includes(chartType);
      },
    },
    mounted() {
      if (process.client) {
        document.onkeyup = ev => {
          const pressESCKey = ev.keyCode === 27;
          if (pressESCKey) {
            this.lockP5Drawing = !this.lockP5Drawing;
          }
        }
      }
    }
  }
</script>

<style lang="scss" scoped>
  .stock-tech-chart {
    height: 100%;
    .record-block {
      min-height: 70px;
      padding: 0 30px 0 0;
      .option-item {
        margin: 5px;
        .option-title {
          width: 90px;
          margin: 0 10px 0 0;
        }
        .option-value {
          width: calc(100% - 110px);
          padding: 0 5px;
          border-radius: 4px;
        }
      }
    }
    .chart-block {
      /*height: calc(100% - 70px);*/
      padding: 0 30px 0 0;
      overflow-y: auto;
    }
  }
</style>
